unit hallar_puntos2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ExtDlgs;

type
  Tinterpolar = class(TForm)
    e_x1: TEdit;
    E_y1: TEdit;
    E_x2: TEdit;
    E_y2: TEdit;
    L_punto1: TLabel;
    L_punto2: TLabel;
    P_solucion: TPanel;
    B_comenzar: TButton;
    B_calcular: TButton;
    B_salir: TButton;
    L_x: TLabel;
    E_x: TEdit;
    b_nuevaX: TButton;
    L_punto3: TLabel;
    E_x3: TEdit;
    E_y3: TEdit;
    M_datos: TMemo;
    RB_interpPolinomica: TRadioButton;
    RB_interpLineal: TRadioButton;
    L_puntosEncontrados: TLabel;
    B_terminar: TButton;
    SaveDialog1: TSaveDialog;
    B_comen: TButton;
    B_salvarDatos: TButton;
    B_almacenar: TButton;
    procedure B_salirClick(Sender: TObject);
    procedure B_comenzarClick(Sender: TObject);
    procedure B_calcularClick(Sender: TObject);
    procedure b_nuevaXClick(Sender: TObject);
    procedure B_terminarClick(Sender: TObject);
    procedure B_salvarDatosClick(Sender: TObject);
    procedure B_almacenarClick(Sender: TObject);
    
  private

    { Private declarations }
  public
    { Public declarations }
  end;

var
  interpolar: Tinterpolar;

implementation

{$R *.dfm}

procedure Tinterpolar.B_salirClick(Sender: TObject);
begin
  close;
end;

procedure Tinterpolar.B_comenzarClick(Sender: TObject);
begin
  E_x1.clear;
  E_y1.clear;
  E_x2.clear;
  E_y2.clear;
  E_x.clear;
  E_x3.Clear;
  E_y3.clear;
  E_x1.Enabled := true;
  E_y1.Enabled := true;
  E_x2.Enabled := true;
  E_y2.Enabled := true;
  E_x3.Enabled := true;
  E_y3.Enabled := true;
  E_x.Enabled := true;
  E_x1.Setfocus;
  P_solucion.Caption := 'SOLUCIN';
  B_comenzar.enabled := false;
  B_calcular.enabled := true;
  B_nuevaX.enabled := false;
  B_salvarDatos.enabled := false;
  RB_interpLineal.enabled := false;
  RB_interpPolinomica.enabled := false;
  M_datos.clear;

end;


{ El boton calcular aplica Mtodo de interpolacin polinmico de las Diferencias
Divididas de Newton o el mtodo de interpolacin lineal segn se elija}


procedure Tinterpolar.B_calcularClick(Sender: TObject);
var
  x,x1,x2,x3,y,y1,y2,y3,a,b,c : real;
  solucion : string;
begin
  B_almacenar.Enabled := true;
  B_terminar.Enabled := true;
  if (RB_interpPolinomica.Checked) then
    begin
      if (E_x.text = '')or (E_x1.text = '') or (E_x2.text = '') or (E_y1.text = '')
      or (E_y2.text = '')  or (E_x3.text = '') or (E_y3.text = '') then
        begin
          showmessage('Introduzca los datos necesarios');
          E_x1.SetFocus;
        end
    else
      begin
         x := strtofloat(E_x.text);
        x1 := strtofloat(E_x1.text);
        y1 := strtofloat(E_y1.Text); //equivale a f(x0) del mtodo
        x2 := strtofloat(E_x2.Text);
        Y2 := strtofloat(E_y2.Text); // idem. f(x1)
        x3 := strtofloat(E_x3.Text);
        Y3 := strtofloat(E_y3.Text); // idem f(x2)
        a :=  (y2-y1)/(x2-x1);        // idem f(x0,x1)
        b := (y3-y2)/(X3-x2);       // idem f(x1,x2)
        c := (b-a)/(x3-x1);           // idem f(x0,x1,x2)
        If (x1 = x2) or (x2 = x3) or (x1 = x3) then
          begin
            showmessage('Los valores de X deber ser diferentes');
            E_x1.setfocus;
          end
        else
          begin
            Y := y1+a*(x-x1)+c*(x-x1)*(x-x2);
            str(y:6:2,solucion);
            P_solucion.Caption := 'Y='+solucion;
            E_x1.Enabled := false;
            E_y1.Enabled := false;
            E_x2.Enabled := false;
            E_y2.Enabled := false;
            E_x.Enabled := false;
            E_x3.Enabled := false;
            E_y3.Enabled := false;
            B_calcular.Enabled := false;
            B_nuevaX.enabled := true;
            B_almacenar.setfocus;
          end;
        end;
      end
  else
    begin
      if (E_x.text = '')or (E_x1.text = '') or (E_x2.text = '') or
      (E_y1.text = '') or (E_y2.text = '')  then
         begin
         showmessage('Introduzca los datos necesarios');
         E_x1.SetFocus;
         end
      else
        begin
          x := strtofloat(E_x.text);
          x1 := strtofloat(E_x1.text);
          y1 := strtofloat(E_y1.Text);
          x2 := strtofloat(E_x2.Text);
          Y2 := strtofloat(E_y2.Text);
          If (x1 = x2) then
            begin
              showmessage('Los valores de X1 y X2 deber ser diferentes');
              E_x2.setfocus;
            end
        else
          begin
            Y := y1+(x-x1)*((y2-y1)/(x2-x1));
            str(y:6:2,solucion);
            P_solucion.Caption := 'Y='+solucion;
            E_x1.Enabled := false;
            E_y1.Enabled := false;
            E_x2.Enabled := false;
            E_y2.Enabled := false;
            E_x.Enabled := false;
            B_calcular.Enabled := false;
            B_nuevaX.enabled := true;
            B_almacenar.setfocus;
          end;
        end;
    end;
end;

  
procedure Tinterpolar.b_nuevaXClick(Sender: TObject);
begin
  E_x.Enabled := true;
  E_x.Setfocus;
  B_calcular.Enabled := true;
  B_comenzar.Enabled := false;
  B_nuevaX.Enabled := false;
end;


procedure Tinterpolar.B_terminarClick(Sender: TObject);
begin
  B_calcular.Enabled := false;
  B_comenzar.Enabled := true;
  B_nuevaX.Enabled := false;
  RB_interpLineal.enabled := true;
  RB_interpPolinomica.enabled := true;
  B_almacenar.Enabled := false;
  B_terminar.Enabled := false;
end;

procedure Tinterpolar.B_salvarDatosClick(Sender: TObject);
begin
  savedialog1.title := 'Guardar interpolaciones realizadas';
  savedialog1.defaultExt := 'txt';
  Savedialog1.filter := 'Archivos de texto (*.txt)|*.txt|Todos los archivos|*.*';
  if saveDialog1.execute then
    begin
      M_datos.Lines.savetofile(savedialog1.filename);
      M_datos.clear;
      B_salvarDatos.Enabled :=false;
    end
  else
    showmessage('Los datos NO han sido salvados');
end;


procedure Tinterpolar.B_almacenarClick(Sender: TObject);
begin
if (E_x.Text <> '')  then
  begin
    if RB_interpLineal.checked then
      begin
        M_datos.Lines[0] := 'INT.LINEAL';
        M_datos.lines.add('X='+E_x.Text+'; '+p_solucion.Caption);
        B_almacenar.enabled := false;
        B_salvardatos.enabled := true;
        b_nuevaX.setfocus;
      end
    else
      begin
        M_datos.Lines[0] := 'INT.POLINMICA';
        M_datos.lines.add('X='+E_x.Text+'; '+p_solucion.Caption);
        B_almacenar.enabled := false;
        B_salvardatos.enabled := true;
        b_nuevaX.setfocus;
      end;
  end
else
  showmessage('No tiene datos para almacenar');
end;

end.
